Rules
- Rules changelog
- Rules examples
- Cloudflare Rules
- Configure a Cloud Connector rule via API
- Configure a Cloud Connector rule in the dashboard
- Configure Cloud Connector rules using Terraform
- Cloud Connector
- Supported cloud providers in Cloud Connector
- Cloud Connector examples
- Route /images to an S3 Bucket using Terraform
- Route /images to an S3 Bucket
- Send EU visitors to a Google Cloud Storage bucket
- Serve /static-assets from Azure Blob Storage
- Create a compression rule via API
- Create a compression rule in the dashboard
- Compression Rules
- Compression Rules settings
- Disable Brotli compression
- Disable compression for AVIF images
- Enable Zstandard compression for default content types
- Use Gzip compression for CSV files
- Compression Rules examples
- Use only Brotli compression for a specific path
- Create a configuration rule via API
- Create a configuration rule in the dashboard
- Configuration Rules
- Response body inspection
- Configuration Rules settings
- Define a single configuration rule using Terraform
- Configuration Rules examples
- Common API calls for Custom Errors
- Create custom error rules
- Edit Error Pages
- Example custom error rules
- Custom Errors
- Troubleshoot Error Pages issues
- Error page types
- Error tokens
- Reference
- Custom Errors parameters
- URL normalization examples
- How URL normalization works
- URL normalization
- Configure URL normalization in the dashboard
- URL normalization settings
- Create an origin rule via API
- Create an origin rule in the dashboard
- Origin Rules FAQ
- Origin Rules settings
- Origin Rules
- Origin Rules API parameter reference
- Change the HTTP Host header and DNS record
- Change the destination port
- Define a single origin rule using Terraform
- Origin Rules examples
- Change URI path and Host header
- Origin Rules tutorials
- Point to Pages with a custom domain
- Point to R2 bucket with a custom domain
- Page Rules
- Manage Page Rules
- How to
- URL forwarding with Page Rules
- Additional reference for Page Rules
- Reference
- Recommended page rules
- Page Rules settings
- Wildcard matching in Page Rules
- Troubleshoot Page Rules - Billing and subscription
- Troubleshoot Page Rules - General
- Troubleshooting
- Reference
- Page Rules migration guide
- Troubleshoot Rules
- Rules simulator changelog
- Use Rules simulator
- Rules simulator
- Rules simulator limitations
- Configure Snippets via API
- Create a snippet in the dashboard
- Configure Snippets using Terraform
- Troubleshoot Snippets
- How Snippets work
- Cloudflare Snippets
- When to use Snippets vs Workers
- A/B testing with same-URL direct access
- Append dates to cookies to use with A/B testing
- Auth with headers
- Send Bot Management information to origin
- Send suspect bots to a honeypot
- Bulk redirect based on a map object
- Country code redirect
- Custom cache
- Debugging logs
- Define CORS headers
- Follow redirects from the origin
- Add HEX timestamp to a request header
- Snippets examples
- Validate JSON web tokens (JWT)
- Maintenance page
- Override a Set-Cookie header with a certain value
- Redirect 403 Forbidden to a different page
- Redirect from one domain to another
- Remove fields from API response
- Remove query strings before sending request to origin
- Remove response headers
- Return information about the incoming request
- Rewrite links on HTML pages
- Change origin and modify paths
- Set security headers
- Send timestamp to origin as a custom header
- Route to a different origin based on origin response
- Sign requests
- Slow down suspicious requests
- Transform Rules
- Troubleshoot Transform Rules
- Add a wildcard CORS response header
- Add a request header with the current bot score
- Add request header with a static value
- Add a request header for subrequests from other zones
- Add a response header with a static value
- Transform Rules examples
- Normalize encoded slashes in URL path
- Remove a request header
- Remove a response header
- Rewrite blog archive URLs
- Rewrite path of moved section of a website
- Rewrite path of archived blog posts
- Rewrite path for object storage bucket
- Rewrite image paths with several URL segments
- Rewrite URL query string
- Rewrite page path for visitors in specific countries
- Set a response header with the current bot score
- Set response header with a static value
- Configure Managed Transforms
- Managed Transforms
- Available Managed Transforms
- Create a request header transform rule via API
- Create a request header transform rule in the dashboard
- Request Header Transform Rules
- Available fields and functions
- Format of HTTP request header names and values
- Reference
- API parameter reference
- Create a response header transform rule via API
- Create a response header transform rule in the dashboard
- Response Header Transform Rules
- Available fields and functions
- Format of HTTP response header names and values
- Reference
- API parameter reference
- Create a URL rewrite rule via API
- Create a URL rewrite rule in the dashboard
- URL Rewrite Rules
- Available fields and functions
- Reference
- URL rewrite parameters
- Redirects
- Bulk Redirects concepts
- Create Bulk Redirects via API
- Create Bulk Redirects in the dashboard
- Bulk Redirects FAQ
- How Bulk Redirects work
- Bulk Redirects
- Configure Bulk Redirects using Terraform
- CSV file format for Bulk Redirects
- Available fields and functions
- Reference
- Bulk Redirects API JSON objects
- URL redirect parameters
- Supported URL components in Bulk Redirects
- Redirect examples
- Perform mobile redirects
- Redirect admin area requests to HTTPS
- Redirect requests from one domain to another
- Redirect requests from one country to a domain
- Redirect requests for a domain to a new domain
- Redirect requests to a different hostname
- Redirect local visitors to specific subdomains
- Redirect visitors to a new page URL
- Redirect from root to WWW
- Redirect from WWW to root
- Remove locale from URL path
- Create a redirect rule via API
- Create a redirect rule in the dashboard
- Single Redirects
- Single Redirects settings
- Create a redirect rule using Terraform
Rules changelog
import { ProductChangelog } from "~/components";
{/* */}
2024-09-20
Automatic DNS Validation for Cloudflare Rules
The Cloudflare dashboard now automatically validates DNS records and Cloudflare for SaaS custom hostnames for rules targeting specific hostnames or URLs. To prevent misconfigured rules and ensure smoother deployments, you will get proactive warnings for missing or misconfigured DNS records and custom hostnames.
2024-09-17
Compression Rules available to all plans with Zstandard support
Compression Rules now support Zstandard compression and are available in all Cloudflare plans. Users in the Free plan will gradually get access throughout 2024.
2024-09-13
Snippets now available in beta
Cloudflare Snippets have transitioned from alpha to beta.
2024-09-10
wildcard_replace() function now supported in URL rewrites
You can now use the wildcard_replace() function in rewrite expressions of URL rewrites.
2024-09-05
New Rules Templates for one-click rule creation
The new Rules > Templates page in the Cloudflare dashboard allows you to create common rules with a single click, featuring dozens of pre-built templates. You can also access these templates directly from each product's rule builder. Also, explore the Examples gallery in the developer docs for real-world use cases and inspiration.
2024-08-22
Simplified UI for Single Redirects with wildcard support
The simplified UI for Single Redirects is now available to all users, making URL redirects easier and more intuitive. This update builds on the recent wildcard support in Ruleset Engine products. Access the new UI under Rules > Redirect Rules. Learn more about wildcard support and our open-source Rust crate in the blog post.
2024-08-20
Cloud Connector now available to all customers
Cloud Connector (beta) is now available to all customers. For setup details, refer to the documentation, explore examples, and check out the blog post.
2024-08-16
Cloud Connector now available to all free customers
Cloud Connector (beta) is now available to all free and a subset of paid customers. This rollout will be gradually extended to all Cloudflare users, simplifying multi-cloud management and enhancing integration with Cloudflare's Connectivity Cloud. For more information, refer to the blog post.
2024-08-12
Cloudflare Snippets limits have been upgraded
Cloudflare Snippets (alpha) now allow multiple subrequests depending on your plan. For more information, refer to the Availability.
2024-07-31
Wildcard support added to Ruleset Engine products
Wildcards are now supported across our Ruleset Engine-based products, including Single Redirects, Cache Rules, Transform Rules, WAF, Waiting Room, and more:
- You can now use the
wildcardandstrict wildcardoperators with any string field in the Ruleset Engine, such as full URI, host, headers, cookies, user-agent, and country. For more details, refer to Operators and Wildcard matching. - In Single Redirects, the
wildcard_replace()function allows you to use segments matched by thewildcardandstrict wildcardoperators in redirect URL targets. For more information, refer to Functions.
2024-07-01
Cloudflare Snippets now available to all paid customers
Cloudflare Snippets (alpha) are now available to all paid customers.
2024-06-03
Cloudflare Snippets now available to all Enterprise customers
Cloudflare Snippets (alpha) are now available to all Enterprise customers. Customers in other paid plans will gradually get access throughout 2024.
2024-05-14
Page Rules migration
The Page Rules migration guide is now available for users interested in transitioning to modern Rules features instead of Page Rules. Explore the guide for detailed instructions on migrating your configurations.
2024-05-13
New Configuration Rules setting for Web Analytics (RUM)
You can now turn off Cloudflare Web Analytics, also known as Real User Monitoring (RUM), for specific requests using a configuration rule.
2024-04-29
New Configuration Rules setting for Cloudflare Fonts
You can now turn on or off Cloudflare Fonts for specific requests using a configuration rule.
2024-03-22
New TLS fields in rule expressions
Customers can now use new fields cf.tls_client_hello_length (the length of the client hello message sent in a TLS handshake), cf.tls_client_random (the value of the 32-byte random value provided by the client in a TLS handshake), and cf.tls_client_extensions_sha1 (the SHA-1 fingerprint of TLS client extensions) in various products built on Ruleset Engine.
2024-03-20
Origin Rules now allow port numbers in Host Header Override
Customers can now use arbitrary port numbers in Host Header Override in Origin Rules. Previously, only hostname was allowed as a value (for example, example.com). Now, you can set the value to hostname:port (for example, example.com:1234) as well.
Rules examples
import { ResourcesBySelector, GlossaryTooltip } from "~/components";
Explore the following examples for Rules.
:::note
We have a separate listing for Cache rules examples.
:::
<ResourcesBySelector directory="rules" types={["example"]} filterables={["products"]} />
Cloudflare Rules
import { CardGrid, Feature, LinkTitleCard, Plan, RelatedProduct, } from "~/components";
Cloudflare Rules allows you to control how Cloudflare handles traffic to your website. For example, redirecting visitors, rewriting URLs, overriding where requests are sent, or customizing Cloudflare settings for specific requests.
Rules features require that your domain (or subdomain) has its DNS records proxied through Cloudflare, meaning traffic passes through the Cloudflare network before reaching your origin server.
Features
Customize Cloudflare configuration settings for matching incoming requests. Customize the behavior of your website or application using short pieces of JavaScript code. Adjust the URI path, query string, and HTTP headers of requests and responses on the Cloudflare global network. Redirect visitors from a source URL to a target URL with a specific HTTP status code. Use Single Redirects or Bulk Redirects depending on your use case. Customize where the incoming traffic will go and with which parameters. Override request properties such as `Host` header, destination hostname, and destination port. Route matching incoming traffic from your website to a public cloud provider such as AWS, Google Cloud, and Azure. Customize the compression applied to responses from Cloudflare's global network to your website visitors, based on the file extension and content type. Trigger certain actions when a request matches a URL pattern.<Feature header="URL normalization" href="/rules/normalization/" cta="Configure URL normalization"
Modify the URLs of incoming requests so that they conform to a consistent
formatting standard.
<Feature header="Custom Errors" href="/rules/custom-errors/" cta="Configure Custom Errors"
Define what custom content to serve for errors returned by an origin server or
by a Cloudflare product, including Workers.
Related products
Control incoming traffic by filtering requests to a zone. You can block or challenge incoming requests according to rules you define.Define rate limits for requests matching an expression, and the action to
perform when those rate limits are reached.
Customize the cache properties of your HTTP requests.
Cloudflare Workers provides a serverless execution environment that allows you
to create new applications or augment existing ones without configuring or
maintaining infrastructure.
More resources
<LinkTitleCard title="Plans" href="https://www.cloudflare.com/plans/#overview" icon="document"
Compare available Cloudflare plans
Configure a Cloud Connector rule via API
import { APIRequest } from "~/components";
You can configure Cloud Connector rules using the Cloudflare API.
Required permissions
The API token used in API requests to manage Cloud Connector rules must have at least the following permission:
- Zone > Cloud Connector > Write
:::note
A token with this permission is only valid for the Cloud Connector endpoints described in this page. You cannot use it to interact with the http_cloud_connector phase via Rulesets API.
:::
Endpoints
To obtain the complete endpoint, append the Cloud Connector endpoints listed below to the Cloudflare API base URL:
https://api.cloudflare.com/client/v4
The {zone_id} argument is the zone ID (a hexadecimal string). You can find this value in the Cloudflare dashboard.
The following table summarizes the available operations.
| Operation | Verb + Endpoint |
|---|---|
| List Cloud Connector rules | GET /zones/{zone_id}/cloud_connector/rules |
| Create/update/delete Cloud Connector rules | PUT /zones/{zone_id}/cloud_connector/rules |
Example API calls
List of Cloud Connector rules
The following example returns a list of existing Cloud Connector rules:
{
"result": [
{
"id": "<RULE_1_ID>",
"provider": "aws_s3",
"expression": "http.request.uri.path wildcard \"/images/*\"",
"description": "Connect to S3 bucket containing images",
"enabled": true,
"parameters": {
"host": "examplebucketwithimages.s3.north-eu.amazonaws.com"
}
}
],
"success": true,
"errors": [],
"messages": []
}
Create/update/delete Cloud Connector rules
:::caution To create a new rule and keep all existing rules, you must include them all in your request body. Omitting an existing rule in the request body will delete the corresponding Cloud Connector rule. :::
The following example request will replace all existing Cloud Connector rules with a single rule:
<APIRequest path="/zones/{zone_id}/cloud_connector/rules" method="PUT" json={[ { expression: 'http.request.uri.path wildcard "/images/*"', provider: "cloudflare_r2", description: "Connect to R2 bucket containing images", parameters: { host: "mybucketcustomdomain.example.com", }, }, ]} />
The required body parameters for each rule are: expression, provider, and parameters.host.
The provider value must be one of the following: cloudflare_r2, aws_s3, azure_storage, gcp_storage, and oci_storage.
Configure a Cloud Connector rule in the dashboard
import { Render, Steps, DashButton } from "~/components";
To configure a Cloud Connector rule in the dashboard:
-
In the Cloudflare dashboard, go to the Cloud Connector page.
-
Select your cloud provider (Cloudflare R2 or an external provider).
-
If you selected Cloudflare R2 in the previous step, select your bucket and your custom domain, and select Next.
If you selected a different storage provider, enter the bucket URL and select Next.:::caution The bucket URL must follow a specific format according to your provider. :::
-
Enter a descriptive name for the rule in Cloud Connector name.
-
Under If, select Custom filter expression and enter an expression to define the traffic that will be redirected to the bucket. For example:
- To route all requests matching
http*://example.com/images/*(HTTPS and HTTP requests) you could enter the following expression:
http.request.full_uri wildcard "http*://example.com/images/*" - To route all requests matching
http*://images.example.com/*(HTTPS and HTTP requests) you could enter the following expression:
http.request.full_uri wildcard "http*://images.example.com/*"
Alternatively, select All incoming requests to redirect all incoming traffic for your zone to the storage bucket you selected.
- To route all requests matching
-
To save and deploy your rule, select Deploy. If you are not ready to deploy the rule, select Save as Draft.
Configure Cloud Connector rules using Terraform
import { Render } from "~/components";
You can create Cloud Connector rules using the Terraform Cloudflare provider.
To get started with Terraform for Cloudflare configuration, refer to Get started.
Required permissions
The API token used by Terraform must have at least the following permission:
- Zone > Cloud Connector > Write
Example configuration
The following example Terraform configuration creates Cloud Connector rules for various supported providers to route traffic between them based on URI paths:
resource "cloudflare_cloud_connector_rules" "cloud_connector_rules" {
zone_id = "<ZONE_ID>"
rules {
description = "Route /data to GCP bucket"
enabled = true
expression = "(http.request.uri.path wildcard \"*/data/*\")"
provider = "gcp_storage"
parameters {
host = "mystorage.storage.googleapis.com"
}
}
rules {
description = "Route /resources to AWS bucket"
enabled = true
expression = "(http.request.uri.path wildcard \"*/resources/*\")"
provider = "aws_s3"
parameters {
host = "mystorage.s3.ams.amazonaws.com"
}
}
rules {
description = "Route /files to Azure bucket"
enabled = true
expression = "(http.request.uri.path wildcard \"*/files/*\")"
provider = "azure_storage"
parameters {
host = "mystorage.blob.core.windows.net"
}
}
rules {
description = "Route /images to R2 bucket"
enabled = true
expression = "(http.request.uri.path wildcard \"*/images/*\")"
provider = "cloudflare_r2"
parameters {
host = "mybucketcustomdomain.example.com"
}
}
}
More resources
Refer to the Terraform Cloudflare provider documentation for more information on the cloudflare_cloud_connector_rules resource.
Cloud Connector
import { ProductAvailabilityText, Render } from "~/components";
Cloud Connector allows you to route matching incoming traffic from your website to a public cloud provider that you define: Cloudflare R2 object storage or an external provider such as AWS, Google Cloud, Microsoft Azure, and Oracle Cloud. With Cloud Connector, you can manage traffic to cloud-hosted content through the same Cloudflare dashboard you use for the rest of your website, without having to configure additional rules.
<Render file="rules-requirements" product="rules" params={{ sentenceIntro: "Cloud Connector requires" }} />
How it works
First, you configure a Cloud Connector rule that specifies:
- The cloud provider and a supported cloud service that will accept traffic.
- The traffic that will be routed to that cloud service.
Then, Cloudflare will create the necessary configurations so that the content is accessible for requests matching your Cloud Connector rule. Your object storage bucket must be publicly accessible for Cloud Connector to work.
Cloud Connector rules are evaluated last in the request evaluation workflow. When a Cloud Connector rule matches and other rules have modified the same settings (such as the Host header), the Cloud Connector rule takes precedence.
Applied configurations
Cloud Connector will perform the following configurations automatically, depending on the cloud provider:
- Modify the
Hostheader. - Adjust SSL/TLS for bucket-related traffic (AWS S3 website endpoints only).
:::note[Additional configurations you may need]
Cloud Connector will not apply any of the following configurations:
- Cache content served from storage bucket: To define custom cache behavior — like when to cache returned objects and for how long — you will need to create a cache rule. For an example rule configuration, refer to Cache Level (Cache Everything).
- Create URL rewrites: To adjust the URL structure from what your website visitors use to obtain a resource and the folder structure being used in the storage bucket, you will need to create a URL rewrite. For example, you could create a URL rewrite to remove the
/filesprefix from URI paths before routing the request to your object storage bucket. For an example configuration, refer to Rewrite path for object storage bucket.
:::
Availability
Cloud Connector is available in beta to all customers. The maximum number of rules depends on your Cloudflare plan:
| Free | Pro | Business | Enterprise | |
|---|---|---|---|---|
| Availability | Yes | Yes | Yes | Yes |
| Number of rules | 10 | 25 | 50 | 300 |
Supported cloud providers in Cloud Connector
import { Render, Steps } from "~/components";
Cloud Connector currently supports the following cloud providers and services:
- Cloudflare R2
- Amazon Web Services - S3
- Google Cloud Platform - Cloud Storage
- Microsoft Azure - Blob Storage
- Oracle Cloud - Object Storage
Cloudflare R2
The Cloudflare R2 bucket must be public and exposed using a custom domain. Buckets exposed using an r2.dev subdomain are not supported.
Additionally, the custom domain must be defined in the same zone where you are configuring the Cloud Connector rule.
Amazon Web Services - S3
The hostname of your S3 bucket URL must have one of the following formats (where * is a wildcard character):
*s3.amazonaws.com*s3.<REGION>.amazonaws.com*s3-website.<REGION>.amazonaws.com*s3-website-<REGION>.amazonaws.com
Cloud Connector supports both subdomain and URI path-style URLs:
- Subdomain-style URLs: Set the hostname to
<BUCKET_NAME>.s3.amazonaws.com. In this case, your files are accessible directly under the root of the bucket. For example,https://example.com/index.htmlwill map tohttps://<BUCKET_NAME>.s3.amazonaws.com/index.html. When using Full (Strict) SSL/TLS mode, the<BUCKET_NAME>cannot include dots (use dashes instead). Refer to SSL connections to AWS S3 endpoints for details. - URI path-style URLs: Set the hostname to
s3.amazonaws.com. Here, your bucket name must be part of the URI path in your requests. For example, if your bucket name is<BUCKET_NAME>, files will be available on paths likehttps://example.com/<BUCKET_NAME>/index.html, and your Cloud Connector rule should filter traffic based on the URI path starting with/<BUCKET_NAME>.
SSL connections to AWS S3 endpoints
The SSL setting applied to requests between Cloud Connector and AWS S3 depends on the type of S3 endpoint you use:
- HTTPS-supported endpoints: For hostnames like
*s3.<REGION>.amazonaws.comand*s3.amazonaws.com, Cloudflare will connect to AWS S3 over HTTPS if you set your zone's SSL/TLS mode to Full or Full (Strict). When using Full (Strict), the bucket name cannot include dots (use dashes instead). - Non-HTTPS endpoints: For website-style hostnames such as
*s3-website.<REGION>.amazonaws.comor*s3-website-<REGION>.amazonaws.com, which do not support HTTPS, Cloudflare will default to Flexible SSL.
Get the bucket URL
- Go to the Amazon S3 console and select Buckets in the navigation pane.
- Select the bucket name.
- Go to the Properties tab.
- Select the Static Website Hosting card. The Endpoint field shows your bucket URL.
For more information, refer to the Amazon S3 documentation.
Google Cloud Platform - Cloud Storage
The hostname of your Cloud Storage bucket URL must be the following (where * is a wildcard character):
*storage.googleapis.com*storage.cloud.google.com
Cloud Connector supports both subdomain and URI path-style URLs:
- Subdomain-style URLs: Set the hostname to
<BUCKET_NAME>.storage.googleapis.com. In this case, your files are accessible directly under the root of the bucket. For example,https://example.com/index.htmlwill map tohttps://<BUCKET_NAME>.storage.googleapis.com/index.html. - URI path-style URLs: Set the hostname to
storage.googleapis.com. Here, your bucket name must be part of the URI path in your requests. For example, if your bucket name is<BUCKET_NAME>, files will be available on paths likehttps://example.com/<BUCKET_NAME>/index.html, and your Cloud Connector rule should filter traffic based on the URI path starting with/<BUCKET_NAME>.
Get the bucket URL
-
Go to the Google Cloud console and select Buckets.
-
Select the bucket name.
-
For one of the files already in the bucket, select the link icon in the Public column to copy the file's public URL to the clipboard. The file URL will have the following format:
https://storage.googleapis.com/<BUCKET_NAME>/<OBJECT_NAME>To obtain the subdomain bucket URL, refactor the file URL to
<BUCKET_NAME>.storage.googleapis.comformat.
To obtain the URI path bucket URL, removehttps://and/<BUCKET_NAME>/<OBJECT_NAME>from the file URL.
If the files in your bucket are not publicly accessible, you must change the bucket permissions. For details, refer to the Google Cloud Storage documentation.
Microsoft Azure - Blob Storage
The hostname of your Blob Storage bucket URL must have one of the following formats:
<BUCKET_NAME>.blob.core.windows.net<BUCKET_NAME>.web.core.windows.net
For Azure Blog Storage, Cloud Connector supports only subdomain URLs like <BUCKET_NAME>.blob.core.windows.net. This means that your files will be accessible directly under the root of the bucket. For example, https://example.com/index.html will map to https://<BUCKET_NAME>.blob.core.windows.net/index.html.
Get the bucket URL
- Go to the Azure portal and select your storage account.
- In the menu pane, under Settings, select Endpoints.
- Get your bucket URL from the Blob service endpoint or the Static website endpoint.
If the blob container is not configured for public access, you must change the container settings. For details, refer to the Azure Storage documentation.
Oracle Cloud Infrastructure Object Storage
Cloud Connector supports Oracle Cloud Infrastructure (OCI) Object Storage through the Amazon S3 Compatibility API.
:::caution[Public buckets only] Cloud Connector does not authenticate requests to OCI. Your bucket must allow anonymous object reads. Private buckets and pre-authenticated request URLs are not supported. :::
Enter an OCI hostname without a protocol, port, or path. Cloud Connector accepts the following formats:
| Addressing style | Hostname format | Request path |
|---|---|---|
| Path style (traditional) | <NAMESPACE>.compat.objectstorage.<REGION>.oraclecloud.com |
/<BUCKET_NAME>/<OBJECT_NAME> |
| Path style (dedicated) | <NAMESPACE>.compat.objectstorage.<REGION>.oci.customer-oci.com |
/<BUCKET_NAME>/<OBJECT_NAME> |
| Virtual-hosted style | <BUCKET_NAME>.vhcompat.objectstorage.<REGION>.oci.customer-oci.com |
/<OBJECT_NAME> |
For path-style endpoints, include the bucket name in the incoming request path. For example, https://example.com/<BUCKET_NAME>/index.html maps to the same path on the OCI endpoint.
For virtual-hosted endpoints, the bucket name is part of the hostname. An incoming request to https://example.com/index.html maps to /index.html on that bucket. OCI requires virtual-hosted bucket names to use a regional scope and a DNS-compatible name that is unique within the region.
For more information, refer to Object Storage Dedicated Endpoints, Amazon S3 Compatibility API Hosted Style Support in Object Storage, and Changing an Object Storage Bucket's Visibility.
Cloud Connector examples
import { ResourcesBySelector } from "~/components";
<ResourcesBySelector directory="rules/cloud-connector/examples/" types={["example"]} />
Route /images to an S3 Bucket using Terraform
import { Render } from "~/components";
The following example defines a single Cloud Connector rule for a zone using Terraform. The rule routes requests to /images on your domain to an AWS S3 bucket.
resource "cloudflare_cloud_connector_rules" "serve_images_in_aws" {
zone_id = "<ZONE_ID>"
rules {
description = "Route images to AWS S3 bucket"
enabled = true
expression = "http.request.full_uri wildcard \"https://<YOUR_HOSTNAME>/images/*\""
provider = "aws_s3"
parameters {
host = "<BUCKET_NAME>.s3.amazonaws.com"
}
}
}
Route /images to an S3 Bucket
import { Steps, DashButton } from "~/components";
To route requests to /images on your domain to an AWS S3 bucket:
-
In the Cloudflare dashboard, go to the Cloud Connector page.
-
Select Amazon S3 as your cloud provider.
-
Enter the bucket URL. You can structure the URL in two ways:
- Subdomain-style URL: Set the hostname to
<BUCKET_NAME>.s3.amazonaws.com. In this case, your files should be organized in the root of the bucket, meaning the URI path will map directly to the file. For example,https://<YOUR_HOSTNAME>/images/file.jpgwill map tohttps://<BUCKET_NAME>.s3.amazonaws.com/images/file.jpg. - URI path-style URL: Set the hostname to
s3.amazonaws.com. Here, your bucket must include a folder namedimages, and files should be placed inside this folder. The URI path will then include the bucket name, likehttps://<YOUR_HOSTNAME>/<BUCKET_NAME>/images/file.jpgmapping tohttps://s3.amazonaws.com/<BUCKET_NAME>/images/file.jpg.
- Subdomain-style URL: Set the hostname to
-
(Optional) Use URL Rewrite Rules to adjust the URL structure. For example, you can create a URL rewrite that changes
/imagesto/<BUCKET_NAME>/imagesto match the URI path-style URL structure. -
(Optional) Use Cache Rules to adjust the caching behavior for objects returned from the bucket. For example, you can create a cache rule that caches every returned object matching the
/images/*URI path for seven days:- If incoming requests match > Custom filter expression:
(starts_with(http.request.uri.path, "/images/")) - Cache eligibility: Eligible for cache
- Edge TTL > Ignore cache-control header and use this TTL: 7 days
- If incoming requests match > Custom filter expression:
-
Select Next and enter a descriptive name like
Route images to S3in Cloud Connector name. -
Under If, select Custom filter expression and enter the following expression:
http.request.full_uri wildcard "http*://<YOUR_HOSTNAME>/images/*"
Replace<YOUR_HOSTNAME>with desired hostname. -
Select Deploy to activate the rule.
This setup will route all traffic matching http*://<YOUR_HOSTNAME>/images/* (HTTPS and HTTP requests) to your S3 bucket. Make sure to replace <YOUR_HOSTNAME> with your actual hostname and adjust the example paths according to your setup.
Send EU visitors to a Google Cloud Storage bucket
import { Steps, DashButton } from "~/components";
To route requests from visitors in the European Union to a Google Cloud Storage bucket:
-
In the Cloudflare dashboard, go to the Cloud Connector page.
-
Select Google Cloud Storage as your cloud provider.
-
Enter the bucket URL. You can structure the URL in two ways:
- Subdomain-style URL: For
<BUCKET_NAME>.storage.googleapis.com, your files should be organized in the root of the bucket. For example,https://<YOUR_HOSTNAME>/index.htmlwill map tohttps://<BUCKET_NAME>.storage.googleapis.com/index.html. - URI path-style URL: If you set the hostname to
storage.googleapis.com, your bucket must include folders corresponding to the intended URI paths. For example, if you wanthttps://<YOUR_HOSTNAME>/eu/index.htmlto map to a file in your bucket, the file should be placed athttps://storage.googleapis.com/<BUCKET_NAME>/eu/index.html.
- Subdomain-style URL: For
-
(Optional) Use URL Rewrite Rules to adjust the URL structure. For example, you can create a URL rewrite that changes
/euto/<BUCKET_NAME>to match the URI path-style URL structure. -
(Optional) Use Cache Rules to adjust the caching behavior for objects returned from the bucket. For example, you can create a cache rule that caches every returned object matching the
/euURI path for seven days (defined through the Edge TTL setting). -
Select Next and enter a descriptive name like
Route EU visitors to GCPin Cloud Connector name. -
Under If, select Custom filter expression and enter the following expression:
(ip.src.is_in_european_union)
This expression targets traffic from European Union users. -
Select Deploy to activate the rule.
This configuration will route traffic from EU visitors to your Google Cloud Storage bucket. Make sure to replace <YOUR_HOSTNAME> with your actual hostname and adjust the example paths according to your setup.
Serve /static-assets from Azure Blob Storage
import { Steps, DashButton } from "~/components";
To serve static assets from an Azure Blob Storage container:
-
In the Cloudflare dashboard, go to the Cloud Connector page.
-
Select Microsoft Azure as your cloud provider.
-
Enter the bucket URL. Use the following URL structure:
- Subdomain-style URL: Set the hostname to
<BUCKET_NAME>.blob.core.windows.net. In this case, your bucket should include a folder namedstatic-assets, and files should be placed inside this folder. For example,https://<YOUR_HOSTNAME>/static-assets/style.csswill map tohttps://<BUCKET_NAME>.blob.core.windows.net/static-assets/style.css.
- Subdomain-style URL: Set the hostname to
-
(Optional) Use URL Rewrite Rules to adjust the URL structure. For example, you can create a URL rewrite that changes
/static-assetsto/my-pages-project/static-assetsto match the file structure of your object storage bucket. -
(Optional) Use Cache Rules to adjust the caching behavior for objects returned from the bucket. For example, you can create a cache rule that caches every returned object matching the
/static-assetsURI path for seven days (defined through the Edge TTL setting). -
Click Next and enter a descriptive name like
Serve static assets from Azurein Cloud Connector name. -
Under If, select Custom filter expression and enter the following expression:
http.request.full_uri wildcard "http*://<YOUR_HOSTNAME>/static-assets/*" -
Select Deploy to activate the rule.
This setup ensures that all traffic matching http*://<YOUR_HOSTNAME>/static-assets/* (HTTPS and HTTP requests) is served from your Azure Blob Storage container. Make sure to replace <YOUR_HOSTNAME> with your actual hostname and adjust the example paths according to your setup.
Create a compression rule via API
import { Render } from "~/components";
Use the Rulesets API to create a compression rule via API.
Basic rule settings
When creating a compression rule via API, make sure you:
- Set the rule action to
compress_response. - Define the parameters in the
action_parametersfield according to the settings you wish to override for matching requests. - Deploy the rule to the
http_response_compressionphase at the zone level.
Procedure
<Render file="rules-creation-workflow" product="rules" params={{ ruleName: "a compression rule", phaseName: "http_response_compression", }} />
Examples
For example API requests, refer to the Examples gallery.
Create a compression rule in the dashboard
import { Render, Steps, DashButton } from "~/components";
-
In the Cloudflare dashboard, go to the Rules Overview page.
-
Select Create rule > Compression Rule.
-
(Optional) Select one of the rule templates that address common use cases. Then, review and adjust the proposed rule configuration.
-
Enter a descriptive name for the rule in Rule name.
-
Under When incoming requests match, select if you wish to apply the rule to default content types (content types that Cloudflare compresses by default), or to requests that match a custom filter expression.
-
(Optional) To define a custom expression, use the Expression Builder (specifying one or more values for Field, Operator, and Value) or manually enter an expression using the Expression Editor. For more information, refer to Edit expressions in the dashboard.
-
Under Compression options, set the compression options.
-
To save and deploy your rule, select Deploy. If you are not ready to deploy your rule, select Save as Draft.
Compression Rules
import { Render } from "~/components";
Use Compression Rules to customize the compression applied to responses from Cloudflare's global network to your website visitors, based on the file extension and content type. Compression Rules are powered by the Ruleset Engine.
Cloudflare compresses some responses by default, based on the content type. With Compression Rules, you can customize the default behavior, which includes defining preferred compression algorithms for particular file types.
When a compression rule matches and lists several compression algorithms (such as gzip and Brotli), Cloudflare selects the first algorithm from your list that the visitor's browser supports. Cloudflare determines browser support from the accept-encoding HTTP request header, which browsers send automatically to indicate which compression formats they can decompress. If multiple compression rules match the same request, the last matching rule takes precedence.
<Render file="rules-requirements" product="rules" params={{ sentenceIntro: "Compression Rules require" }} />
Get started
Alternatively, follow the instructions in the following pages to get started:
Availability
Compression Rules are available in all Cloudflare plans.
| Free | Pro | Business | Enterprise | |
|---|---|---|---|---|
| Availability | Yes | Yes | Yes | Yes |
| Number of rules | 10 | 25 | 50 | 300 |
Relevant fields
The following fields are commonly used in expressions of compression rules:
| Field in Expression Builder | Field name |
|---|---|
| Media Type | http.response.content_type.media_type |
| File extension | http.request.uri.path.extension |
| N/A | raw.http.request.uri.path.extension |
Important remarks
-
If a compression rule matches but the visitor's browser does not support any of the compression algorithms configured in the rule (based on the
accept-encodingrequest header), the response will not be compressed. -
If a compression rule matches but the origin server's response includes a
cache-control: no-transformHTTP header, the compression rule will not modify the response. Origin servers use this header to indicate that intermediaries (like Cloudflare) should not alter the response body.
<Render file="troubleshoot-rules-with-trace" product="rules" params={{ rulesFeatureName: "Compression Rules" }} />
Compression Rules settings
import { Details, Badge } from "~/components";
Compression Rules support the configuration settings covered in the following sections.
Dashboard configuration settings
Enable Zstandard (Zstd) compression
Sets Zstandard as the preferred compression algorithm. If it is not supported, will automatically fall back to Brotli, Gzip, or uncompressed data.
Enable Brotli and Gzip compression
Enables Cloudflare's default compression setting. Brotli is the preferred compression algorithm. It will automatically fall back to Gzip or to uncompressed data.
Disable compression
Disables compression for matching requests. Also disables Cloudflare's default compression behavior.
Custom
Defines a custom order for compression algorithms.
Allowed values are the following:
- Gzip: Use the Gzip compression algorithm, if supported by the website visitor.
- Brotli: Use the Brotli compression algorithm, if supported by the website visitor.
- Zstandard: Use the Zstandard (Zstd) compression algorithm, if supported by the website visitor.
- Auto: Compress the response according to the algorithms supported by the website visitor (if any). Cloudflare will define the order of preference for the compression algorithms, which may change in the future. Has the same behavior of the Enable compression option.
- Default: Use Cloudflare's default compression behavior, which depends on the response content type.
If you specify only Gzip, Brotli, or Zstandard and no algorithm matches, the response will have no compression. To configure a fallback compression mechanism, add Auto to the list.
:::note The compression applied by the Default option takes into account any configured compression rules that match incoming requests. :::
API configuration settings
The configuration object supported by the compress_response action has the following format:
"action_parameters": {
"algorithms": [
{ "name": "<VALUE1>" },
{ "name": "<VALUE2>" },
// ...
]
}
The algorithms list must contain at least one item.
The supported algorithm values are:
gzip: Use the Gzip compression algorithm, if supported by the website visitor.brotli: Use the Brotli compression algorithm, if supported by the website visitor.zstd: Use the Zstandard compression algorithm, if supported by the website visitor.none: Do not use any compression algorithm.auto: Compress the response according to the algorithms supported by the website visitor (if any). Cloudflare will define the order of preference for the compression algorithms, which may change in the future.default: Use Cloudflare's default compression behavior, which depends on the response content type.
If you include none, default, or auto in the list, it must be the last value in the list.
When you specify only the gzip, brotli, or zstd algorithms, if no algorithm matches then the response will have no compression. To configure a fallback compression mechanism, add auto to the list.
For API examples, refer to the Examples gallery.
Disable Brotli compression
import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";
The following example rule will disable Brotli compression for all incoming requests of a given zone. The only available compression algorithm will be Gzip.
When incoming requests match
- All incoming requests
Then
- Compression options: Custom
- Define a custom order for compression types:
Gzip
If the client does not support Gzip compression, the response will be uncompressed.
The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:
<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "always_use_gzip", expression: "true", action: "compress_response", action_parameters: { algorithms: [{ name: "gzip" }], }, }, ], }} />
Disable compression for AVIF images
import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";
The following example rule will disable compression for AVIF images, based on either the content type or the file extension specified in the request.
When incoming requests match
- Custom filter expression:
- Media Type equals
image/avifOR - File extension equals
avif
- Media Type equals
Then
- Compression options > Disable compression
The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:
<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "disable_compression_for_avif", expression: 'http.response.content_type.media_type eq "image/avif" or http.request.uri.path.extension eq "avif"', action: "compress_response", action_parameters: { algorithms: [{ name: "none" }], }, }, ], }} />
Enable Zstandard compression for default content types
import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";
The following example rule will turn on Zstandard compression for response content types where Cloudflare applies compression by default. If the client does not support Zstandard compression, it will use Brotli or Gzip compression as a fallback.
When incoming requests match
- Custom filter expression:
- Media Type is in
text/html, text/richtext, text/plain, text/css, text/x-script, text/x-component, text/x-java-source, text/x-markdown, application/javascript, application/x-javascript, text/javascript, text/js, image/x-icon, image/vnd.microsoft.icon, application/x-perl, application/x-httpd-cgi, text/xml, application/xml, application/rss+xml, application/vnd.api+json, application/x-protobuf, application/json, multipart/bag, multipart/mixed, application/xhtml+xml, font/ttf, font/otf, font/x-woff, image/svg+xml, application/vnd.ms-fontobject, application/ttf, application/x-ttf, application/otf, application/x-otf, application/truetype, application/opentype, application/x-opentype, application/font-woff, application/eot, application/font, application/font-sfnt, application/wasm, application/javascript-binast, application/manifest+json, application/ld+json, application/graphql+json, application/geo+json
- Media Type is in
Then
- Compression options: Custom
- Define a custom order for compression types:
Zstandard,Brotli,Gzip
The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:
<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "use_zstd_compression", expression: '(http.response.content_type.media_type in {"text/html" "text/richtext" "text/plain" "text/css" "text/x-script" "text/x-component" "text/x-java-source" "text/x-markdown" "application/javascript" "application/x-javascript" "text/javascript" "text/js" "image/x-icon" "image/vnd.microsoft.icon" "application/x-perl" "application/x-httpd-cgi" "text/xml" "application/xml" "application/rss+xml" "application/vnd.api+json" "application/x-protobuf" "application/json" "multipart/bag" "multipart/mixed" "application/xhtml+xml" "font/ttf" "font/otf" "font/x-woff" "image/svg+xml" "application/vnd.ms-fontobject" "application/ttf" "application/x-ttf" "application/otf" "application/x-otf" "application/truetype" "application/opentype" "application/x-opentype" "application/font-woff" "application/eot" "application/font" "application/font-sfnt" "application/wasm" "application/javascript-binast" "application/manifest+json" "application/ld+json" "application/graphql+json" "application/geo+json"})', action: "compress_response", action_parameters: { algorithms: [{ name: "zstd" }, { name: "brotli" }, { name: "gzip" }], }, }, ], }} />
Use Gzip compression for CSV files
import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";
The following example rule will configure Gzip compression as the preferred compression method for CSV files. If the visitor does not support this algorithm, Cloudflare will try to compress the response using a different algorithm supported by the visitor.
When incoming requests match
- Custom filter expression:
- File extension equals
csv
- File extension equals
Then
- Compression options: Custom
- Define a custom order for compression types:
Gzip,Auto
The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:
<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "use_gzip_for_csv", expression: 'http.request.uri.path.extension eq "csv"', action: "compress_response", action_parameters: { algorithms: [{ name: "gzip" }, { name: "auto" }], }, }, ], }} />
Compression Rules examples
import { ResourcesBySelector } from "~/components";
<ResourcesBySelector directory="rules/compression-rules/examples/" types={["example"]} />
Use only Brotli compression for a specific path
import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";
The following example rule will configure only Brotli compression for a specific URI path.
When incoming requests match
- Custom filter expression:
- URI Path equals
/download/assets.tar
- URI Path equals
Then
- Compression options: Custom
- Define a custom order for compression types:
Brotli
Since the rule configuration does not include Auto at the end of the custom algorithms list, the response will be uncompressed if the web visitor does not support Brotli.
The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:
<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "use_only_brotli_for_assets_tar", expression: 'http.request.uri.path eq "/download/assets.tar"', action: "compress_response", action_parameters: { algorithms: [{ name: "brotli" }], }, }, ], }} />
Create a configuration rule via API
import { Details, Render, APIRequest } from "~/components";
Use the Rulesets API to create configuration rules via API.
Basic rule settings
When creating a configuration rule via API, make sure you:
- Set the rule action to
set_config. - Define the parameters in the
action_parametersfield according to the settings you wish to override for matching requests. - Deploy the rule to the
http_config_settingsphase at the zone level.
Procedure
<Render file="rules-creation-workflow" product="rules" params={{ ruleName: "a configuration rule", phaseName: "http_config_settings", }} />
Make sure your API token has the required permissions to perform the API operations.
Example requests
The following example sets the rules of an existing phase ruleset ({ruleset_id}) to a single configuration rule — enabling Email Obfuscation and Browser Integrity Check for the contacts page — using the Update a zone ruleset operation:
<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "enable_email_obfuscation_bic", expression: 'starts_with(http.request.uri.path, "/contact-us/")', description: "Obfuscates email addresses and enables BIC in contacts page", action: "set_config", action_parameters: { email_obfuscation: true, bic: true, }, }, ], }} />
The following example sets the rules of an existing phase ruleset ({ruleset_id}) to a single configuration rule — turning on Under Attack mode for the administration area — using the Update a zone ruleset operation:
<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "enable_under_attack_in_admin", expression: 'http.host eq "admin.example.com"', description: "Turn on Under Attack mode for admin area", action: "set_config", action_parameters: { security_level: "under_attack", }, }, ], }} />
Required API token permissions
The API token used in API requests to manage configuration rules must have at least the following permission:
- Zone > Config Rules > Edit
Create a configuration rule in the dashboard
import { Render, Steps, DashButton } from "~/components";
-
In the Cloudflare dashboard, go to the Rules Overview page.
-
Select Create rule > Configuration Rule.
-
(Optional) Select one of the rule templates that address common use cases. Then, review and adjust the proposed rule configuration.
-
Enter a descriptive name for the rule in Rule name.
-
Under When incoming requests match, select if you wish to apply the rule to all incoming requests or only to requests that match a custom filter expression.
-
(Optional) To define a custom expression, use the Expression Builder (specifying one or more values for Field, Operator, and Value) or manually enter an expression using the Expression Editor. For more information, refer to Edit expressions in the dashboard.
-
Under Then the settings are, add the configuration settings you wish to change for requests matching the rule expression.
-
To save and deploy your rule, select Deploy. If you are not ready to deploy your rule, select Save as Draft.
Configuration Rules
import { Render } from "~/components";
Configuration Rules allow you to customize certain Cloudflare configuration settings for matching incoming requests. For example, you can turn off specific features for certain URL paths or change settings based on the visitor's country.
Each configuration rule includes an expression that defines which requests the rule applies to, based on properties like URL path, hostname, or request header. For more information on expressions, refer to Expressions and Edit expressions in the dashboard.
<Render file="rules-requirements" product="rules" params={{ sentenceIntro: "Configuration Rules require" }} />
Rules templates
Availability
The number of available configuration rules varies according to your Cloudflare plan:
| Free | Pro | Business | Enterprise | |
|---|---|---|---|---|
| Availability | Yes | Yes | Yes | Yes |
| Number of rules | 10 | 25 | 50 | 300 |
Execution order
<Render file="troubleshoot-rules-with-trace" product="rules" params={{ rulesFeatureName: "Configuration Rules" }} />
Response body inspection
import { Steps } from "~/components";
When no enabled feature needs response content, Cloudflare can send data to the client as it arrives. Some features inspect or change response content at the edge.
Inspection can hold part of a response at the edge. This may increase time to first byte (TTFB) or delay incremental delivery. The amount of data held depends on the feature and response.
Features that inspect response bodies
Cloudflare features primarily inspect responses with a Content-Type of text/html. Some features change the body, while others only read it.
The following features can change HTML response bodies when turned on and applicable:
| Feature | Body change |
|---|---|
| AI Labyrinth | Adds invisible links for unauthorized AI crawlers |
| Always Online | Adds a banner to archived pages |
| Automatic HTTPS Rewrites | Rewrites eligible HTTP links to HTTPS |
| Cloudflare challenge features | Injects challenge scripts or returns challenge content |
| Cloudflare Fonts and Automatic Platform Optimization | Rewrites Google Fonts references |
| Email Address Obfuscation | Obfuscates email addresses in page content |
| Markdown for Agents | Converts HTML to Markdown for eligible requests |
| Replace insecure JavaScript libraries | Rewrites supported insecure library URLs |
| Rocket Loader | Changes script loading behavior |
| Web Analytics | Injects the Real User Monitoring beacon |
When Response Body Buffering is set to None, these features do not change the response body.
Security and AI features may also read HTML without changing it. Prefetch URLs reads URL manifests served as text/plain.
This list excludes explicit rules that inspect response content. Review each rule separately when troubleshooting.
Streaming considerations
Response body inspection most often affects progressive HTML and plain-text streams. It can affect other responses selected by explicit inspection rules. A client may receive data later or in larger groups than the origin sent it.
Set an accurate Content-Type at your origin. Do not serve streaming API responses as text/html or text/plain unless that media type is required.
The Cache-Control: no-transform response directive prevents body changes by supported features. It does not prevent read-only inspection. Refer to Cache-Control directives for other effects of this directive.
Isolate inspection issues
If a response stops streaming after you proxy it through Cloudflare:
- Verify that the origin sends data incrementally without Cloudflare.
- Check the origin response's
Content-TypeandCache-Controlheaders. - Review features and rules that apply to the response path.
- Create a path-specific Configuration Rule that sets Response Body Buffering to None.
- Test the response again through Cloudflare.
The None setting streams the body without inspection. It can prevent security, optimization, and analytics features from working on matching responses. Use the narrowest matching expression possible.
For setting values and API configuration, refer to Response Body Buffering.
Configuration Rules settings
import { Details, Render } from "~/components";
You can change the configuration settings described below in a configuration rule.
Automatic HTTPS Rewrites
Automatic HTTPS Rewrites prevents end users from seeing Mixed content errors by rewriting URLs from http to https for resources or links on your website that can be served with HTTPS.
Use this setting to turn on or off Automatic HTTPS Rewrites for matching requests.
API configuration property name: "automatic_https_rewrites" (boolean).
"action_parameters": {
"automatic_https_rewrites": true
}
Browser Integrity Check
Browser Integrity Check blocks access to pages based on specific HTTP headers commonly abused by spammers.
Use this setting to turn on or off Browser Integrity Check for matching requests.
API configuration property name: "bic" (boolean).
"action_parameters": {
"bic": true
}
Disable Real User Monitoring (RUM)
Cloudflare Web Analytics, also known as Real User Monitoring (RUM), is Cloudflare's free, privacy-first analytics for your website.
Use this setting to turn off Web Analytics for matching requests.
API configuration property name: "disable_rum" (boolean).
"action_parameters": {
"disable_rum": true
}
Disable Zaraz
Cloudflare Zaraz gives you complete control over third-party tools and services for your website, and allows you to offload them to the Cloudflare global network.
Use this setting to turn off Zaraz for matching requests.
API configuration property name: "disable_zaraz" (boolean).
"action_parameters": {
"disable_zaraz": true
}
Email Obfuscation
Email Obfuscation prevents spam by hiding email addresses from bots and harvesters while keeping them visible to human visitors to your site.
Use this setting to turn on or off Email Obfuscation for matching requests.
API configuration property name: "email_obfuscation" (boolean).
"action_parameters": {
"email_obfuscation": false
}
Fonts
Cloudflare Fonts rewrites Google Fonts to be delivered from a website's own origin, eliminating the need to rely on third-party font providers.
Use this setting to turn on or off Cloudflare Fonts for matching requests.
API configuration property name: "fonts" (boolean).
"action_parameters": {
"fonts": false
}
Hotlink Protection
Hotlink Protection prevents your images from being used by other sites, potentially reducing the bandwidth consumed by your origin server.
Use this setting to turn on or off Hotlink Protection for matching requests.
API configuration property name: "hotlink_protection" (boolean).
"action_parameters": {
"hotlink_protection": false
}
I'm Under Attack
When enabled, Under Attack mode performs additional security checks to help mitigate layer 7 DDoS attacks. Validated users access your website and suspicious traffic is blocked.
Use this setting to turn on or off Under Attack mode for matching requests.
API configuration property name: "security_level" (string).
API values: "off", "essentially_off", "under_attack".
"action_parameters": {
"security_level": "under_attack"
}
Markdown for Agents
Markdown for Agents automatically converts HTML to Markdown for requests that use content negotiation headers (Accept: text/markdown).
Use this setting to turn on or off Markdown for Agents for matching requests.
API configuration property name: "content_converter" (boolean).
"action_parameters": {
"content_converter": true
}
Opportunistic Encryption
Opportunistic Encryption allows browsers to access HTTP URIs over an encrypted TLS channel.
Use this setting to turn on or off Opportunistic Encryption for matching requests.
API configuration property name: "opportunistic_encryption" (boolean).
"action_parameters": {
"opportunistic_encryption": true
}
Polish
Cloudflare Polish is a one-click image optimization product that automatically optimizes images in your site.
Use this setting to configure Polish for matching requests:
- Off
- Lossless
- Lossy
- WebP
Refer to Compression options for more information on these values.
API configuration property name: "polish" (string).
API values: "off", "lossless", "lossy", "webp".
"action_parameters": {
"polish": "webp"
}
Request Body Buffering
Use the Request Body Buffering setting to configure the request body buffering mode for matching requests:
- Standard (default): Allows Cloudflare products to inspect a prefix of the request body when necessary for enabled functionality on your zone.
- Full: Buffers the entire request body before sending the request to your origin server.
- None: Strictly no buffering. The request body is streamed directly to the origin server without inspection.
:::caution Setting request body buffering to None may break functionality that requires body inspection. In particular, this can impact the effectiveness of the Web Application Firewall (WAF) and other security features that rely on analyzing request bodies to detect and block threats. :::
API configuration property name: "request_body_buffering" (string).
API values: "standard", "full", "none".
"action_parameters": {
"request_body_buffering": "full"
}
Response Body Buffering
Use the Response Body Buffering setting to configure the response body buffering mode for matching requests:
- Standard (default): Allows Cloudflare products to inspect a prefix of the response body when necessary for enabled functionality on your zone.
- None: Strictly no buffering. The response body is streamed directly to the client. Features that change HTML response bodies do not apply their changes.
For features that inspect response content and troubleshooting guidance, refer to Response body inspection.
:::caution Setting response body buffering to None may break functionality that requires body inspection. In particular, this can impact the effectiveness of the Web Application Firewall (WAF) and other security features that rely on analyzing response bodies to detect and block threats. :::
API configuration property name: "response_body_buffering" (string).
API values: "standard", "none".
"action_parameters": {
"response_body_buffering": "standard"
}
Rocket Loader
Rocket Loader prioritizes your website's content (such as text, images, and fonts) by deferring the loading of all your JavaScript code until after rendering.
Use this setting to turn on or off Rocket Loader for matching requests.
API configuration property name: "rocket_loader" (boolean).
"action_parameters": {
"rocket_loader": true
}
SSL
SSL/TLS encryption modes control the scheme (http:// or https://) that Cloudflare uses to connect to your origin web server and how SSL certificates presented by your origin will be validated.
Use this setting to configure the SSL/TLS encryption mode for matching requests:
- Off
- Flexible
- Full
- Strict
- Origin Pull
Refer to Available encryption modes for more information on these values.
API configuration property name: "ssl" (string).
API values: "off", "flexible", "full", "strict", "origin_pull".
"action_parameters": {
"ssl": "flexible"
}
Define a single configuration rule using Terraform
import { Render } from "~/components";
The following example defines a single configuration rule for a zone using Terraform. The rule disables Email Obfuscation and Browser Integrity Check for API requests.
# Disable a couple of Cloudflare settings for API requests
resource "cloudflare_ruleset" "http_config_rules_example" {
zone_id = "<ZONE_ID>"
name = "Config rules ruleset"
description = "Set configuration rules for incoming requests"
kind = "zone"
phase = "http_config_settings"
rules {
ref = "disable_obfuscation_bic"
description = "Disable email obfuscation and BIC for API requests"
expression = "(http.request.uri.path matches \"^/api/\")"
action = "set_config"
action_parameters {
email_obfuscation = false
bic = false
}
}
}
Configuration Rules examples
import { ResourcesBySelector } from "~/components";
<ResourcesBySelector directory="rules/configuration-rules/examples/" types={["example"]} />
Common API calls for Custom Errors
import { APIRequest } from "~/components";
The following sections provide examples of common API calls for managing custom error assets and Error Pages at the zone level.
To perform the same operations at the account level, use the corresponding account-level API endpoints.
Create a custom error asset
The following POST request creates a new custom error asset in a zone based on the provided URL:
curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN" \
--json '{
"name": "500_error_template",
"description": "Standard 5xx error template page",
"url": "https://example.com/errors/500_template.html"
}'
{
"result": {
"name": "500_error_template",
"description": "Standard 5xx error template page",
"url": "https://example.com/errors/500_template.html",
"last_updated": "2025-02-10T11:36:07.810215Z",
"size_bytes": 2048
},
"success": true
}
To create an asset at the account level, use the account-level endpoint:
https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/custom_pages/assets
List custom error assets
The following GET request retrieves a list of custom error assets configured in the zone:
curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN"
{
"result": [
{
"name": "500_error_template",
"description": "Standard 5xx error template page",
"url": "https://example.com/errors/500_template.html",
"last_updated": "2025-02-10T11:36:07.810215Z",
"size_bytes": 2048
}
// ...
],
"success": true,
"errors": [],
"messages": [],
"result_info": {
"count": 2,
"page": 1,
"per_page": 20,
"total_count": 2,
"total_pages": 1
}
}
To retrieve a list of assets at the account level, use the account-level endpoint:
https://api.cloudflare.com/client/v4/accounts/$ZONE_ID/custom_pages/assets
Update a custom error asset
The following PUT request updates the URL of an existing custom error asset at the zone level named 500_error_template:
curl --request PUT \
"https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets/500_error_template" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN" \
--json '{
"description": "Standard 5xx error template page",
"url": "https://example.com/errors/500_new_template.html"
}'
{
"result": {
"name": "500_error_template",
"description": "Standard 5xx error template page",
"url": "https://example.com/errors/500_new_template.html",
"last_updated": "2025-02-10T13:13:07.810215Z",
"size_bytes": 3145
},
"success": true
}
You can update the asset description and URL. You cannot update the asset name after creation.
If you provide the same URL when updating an asset, Cloudflare will fetch the URL again, along with its resources.
To update an asset at the account level, use the account-level endpoint:
https://api.cloudflare.com/client/v4/accounts/{account_id}/custom_pages/assets/{asset_name}
Get a custom error asset
The following GET request retrieves the details of an existing custom error asset at the zone level named 500_error_template:
curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets/500_error_template" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN"
{
"result": {
"name": "500_error_template",
"description": "Standard 5xx error template page",
"url": "https://example.com/errors/500_new_template.html",
"last_updated": "2025-02-10T13:13:07.810215Z",
"size_bytes": 3145
},
"success": true
}
To retrieve an asset at the account level, use the account-level endpoint:
https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/custom_pages/assets/$ASSET_NAME
Delete a custom error asset
The following DELETE request deletes an existing custom error asset at the zone level named 500_error_template:
curl --request DELETE \
"https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets/500_error_template" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN"
If the request is successful, the response will have a 204 HTTP status code.
To delete an asset at the account level, use the account-level endpoint:
https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/custom_pages/assets/$ASSET_NAME
Get error page
This example obtains the current configuration for the Rate limiting block error page (with ID ratelimit_block).
<APIRequest path="/zones/{zone_id}/custom_pages/{identifier}" method="GET" parameters={{ identifier: "ratelimit_block", }} />
{
"result": {
"id": "ratelimit_block",
"description": "Rate limit Block",
"required_tokens": [],
"preview_target": "block:rate-limit",
"created_on": "2025-06-03T08:33:17.091587Z",
"modified_on": "2025-06-03T08:33:17.091587Z",
"url": null,
"state": "default"
},
"success": true,
"errors": [],
"messages": []
}
The response indicates that the page is currently set to the Cloudflare default page ("state": "default").
For a list of error page identifiers, refer to Error page types.
Update error page
This example defines a custom error page for Rate limiting block errors (with ID ratelimit_block) based on the provided URL.
<APIRequest path="/zones/{zone_id}/custom_pages/{identifier}" method="PUT" parameters={{ identifier: "ratelimit_block", }} json={{ state: "customized", url: "https://example.com/rate_limiting_block_error_page.html", }} />
{
"result": {
"id": "ratelimit_block",
"description": "Rate limit Block",
"required_tokens": [],
"preview_target": "block:rate-limit",
"created_on": "2025-06-03T08:33:17.091587Z",
"modified_on": "2025-06-03T08:35:32.639114Z",
"url": "https://example.com/rate_limiting_block_error_page.html",
"state": "customized"
},
"success": true,
"errors": [],
"messages": []
}
To set the error page back to the default page, use "state": "default" in the request body.
For a list of error page identifiers, refer to Error page types.
More resources
Create custom error rules
import { APIRequest, Render, Steps, DashButton } from "~/components";
In the dashboard
Create a custom error rule {/* create-a-custom-error-rule-dashboard */}
-
In the Cloudflare dashboard, go to the Rules Overview page.
-
Select Create rule > Custom Error Rule.
-
Enter a descriptive name for the rule in Rule name.
-
Under If incoming requests match, select one of the following options:
-
Custom filter expression: The rule will only apply to traffic matching a custom expression. Define the rule expression to configure which requests should be rewritten. Use either the Expression Builder or the Expression Editor to define the custom expression. For more information, refer to Edit expressions in the dashboard.
-
All incoming requests: The rule will apply to all responses with a
400status code or above, except for block and challenge actions issued by Cloudflare’s security products.
-
-
In Deliver a custom error response, select the response type (either Custom error asset or one of the available inline responses).
If you select Custom error asset, select an existing custom error asset in Asset, or select Create new asset to create a new custom error asset.
If you select JSON response, HTML response, Text response, or XML response, enter the custom error response you want to send to web site visitors in JSON response, HTML response, Text response, or XML response, respectively. The response can include error tokens that Cloudflare will replace with real values before sending the response to the visitor. The maximum response size is 10 KB.
-
(Optional) In Response code, enter the HTTP status code of the response (an integer value between
400and999). If provided, this value will override the current response status code. -
(Optional) Under Place at, define where to place the rule in the rules list: first rule in the list, last rule in the list, or in a custom position (after a given rule).
-
To save and deploy your rule, select Deploy. If you are not ready to deploy your rule, select Save as Draft.
Create a custom error asset {/* create-a-custom-error-asset-dashboard */}
- In the Create Custom Error Asset sidebar, enter a name for the asset in Asset name.
- (Optional) Enter a description for the asset in Description.
- In URL, enter the URL of the page you want to fetch and store in Cloudflare's global network. Cloudflare will fetch all the page resources and store a minified version of the page you can use in one or more custom error rules.
- Select Save.
To review existing custom error assets, go to Rules > Settings > Custom Error Assets tab.
Via API
To configure a custom error rule via API:
- (Optional) Create a custom error asset based on a URL you provide.
- Create a custom error rule in the
http_custom_errorsphase, using the Rulesets API.
Create a custom error asset {/* create-a-custom-error-asset-api */}
The following POST request creates new a custom error asset in a zone based on the provided URL:
curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets" \
--header "Authorization: Bearer <API_TOKEN>" \
--json '{
"name": "500_error_template",
"description": "Standard 5xx error template page",
"url": "https://example.com/errors/500_template.html"
}'
{
"result": {
"name": "500_error_template",
"description": "Standard 5xx error template page",
"url": "https://example.com/errors/500_template.html",
"last_updated": "2025-02-10T11:36:07.810215Z",
"size_bytes": 2048
},
"success": true
}
Create a custom error rule {/* create-a-custom-error-rule-api */}
When creating a custom error rule via API, make sure you:
- Set the rule action to
serve_error. - Define the rule parameters in the
action_parametersfield according to response type. - Deploy the rule to the
http_custom_errorsphase.
The first rule in the http_custom_errors phase ruleset that matches will be applied. No other rules in the ruleset will be matched or applied. Additionally, custom error rules defined at the zone level will have priority over rules defined at the account level.
General procedure
Follow this workflow to create a custom error rule for a given zone via API:
-
Use the List zone rulesets operation to check if there is already a ruleset for the
http_custom_errorsphase at the zone level. -
If the phase ruleset does not exist, create it using the Update a zone entry point ruleset operation, which allows you to create a ruleset if it does not exist and update all the rules in the ruleset. Create the ruleset in the
http_custom_errorsphase.If the phase ruleset already exists, use the Update a zone entry point ruleset operation to replace all the rules in the ruleset, or the Add a rule to a ruleset operation to add a rule to the existing rules in the ruleset.
To create a custom error rule at the account level, use the corresponding account-level API endpoints.
Example
This example configures a custom error rule returning a previously created custom error asset named 500_error_template for responses with a 500 HTTP status code.
<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "serve_500_template", action: "serve_error", action_parameters: { asset_name: "500_error_template", content_type: "text/html", }, expression: "http.response.code eq 500", enabled: true, }, ], }} />
This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.
Required API token permissions
The API token used in API requests to manage Custom Error Rules and Custom Error Assets must have at least the following permission:
- Custom Error Rules > Edit
Edit Error Pages
import { Render, Details, DashButton, Steps, Tabs, TabItem, } from "~/components";
You can define custom Error Pages for the following errors and challenges:
For more information on the different types of Error Pages, refer to Error page types.
To return custom error responses for requests that match specific conditions, use Custom Error Rules instead.
1. Design your custom error page
Before defining a custom error page in your Cloudflare account, you will need to design and code that page. It can be hosted on your own web server or using a Cloudflare product like Snippets.
When designing your custom error page, you can include page-specific custom error tokens. Each custom error token provides diagnostic information that appears on the error page.
To display a custom page for each error, create a separate page per error. For example, to create a custom error page for both IP/Country Block and WAF block, you must design and publish two separate pages.
:::note[Notes]
- Your custom error page should include a page-specific custom error token if applicable and cannot exceed 1.5 MB (1,500,000 bytes). Also, it must include HTML
<head>and</head>tags. - Make sure that the
referrermeta tag is not present in your custom error page's HTML code since it will disrupt Cloudflare challenges:<meta name="referrer" (...) />
:::
You can use the following template to start building your error page:
<html>
<head></head>
<body>
::[REPLACE WITH CUSTOM ERROR TOKEN NAME]::
</body>
</html>
The following HTML code is an example error page for 5XX errors without styling:
<!doctype html>
<html>
<head>
<meta charset="utf-8" />
<title>5XX Level Errors page</title>
</head>
<body>
<h1>5XX Level Errors</h1>
<h2>::CLOUDFLARE_ERROR_500S_BOX::</h2>
</body>
</html>
2. Update an error page in the dashboard
You can define an error page at the zone level or for your entire account. Zone-level error pages have priority over account-level error pages.
To edit a zone-level custom error page:
-
In the Cloudflare dashboard, go to the Error Pages page.
-
Identify your desired custom error page type.
-
(Optional) To preview the current error page (default or custom), select the link in the Show column.
-
To edit the error page, select the three dots > Edit next to the page type you previously identified.
-
To use Cloudflare's default page, select Cloudflare default page. To provide a custom error page, select Custom page and enter the URL of the custom error page you created.
-
Select Confirm.
To update an account-level custom error page:
-
In the Cloudflare dashboard, go to the Settings page.
-
Go to Error Pages and identify your desired custom error page type.
-
(Optional) To preview the current error page (default or custom), select the link in the Show column.
-
To edit the error page, select the three dots > Edit next to the page type you previously identified.
-
To use Cloudflare's default page, select Cloudflare default page. To provide a custom error page, select Custom page and enter the URL of the custom error page you created.
-
Select Confirm.
Fetch custom error page again
After successfully setting the content of the custom error page in Error Pages, you can remove the page from your origin server.
If in the future, you need to update your custom error page, you must fetch the page again, even if the page URL remains unchanged. In this case, next to the page type you want to update, select the three dots > Fetch custom page again.
Example custom error rules
import { Tabs, TabItem, APIRequest, Render } from "~/components";
The provided examples use the following fields in their rule expressions:
-
http.response.code(Response Status Code): Represents the HTTP status code returned to the client, either set by a Cloudflare product or returned by the origin server. Use this field to customize the response for error codes returned by the origin server or by a Cloudflare product such as a Worker. -
cf.response.1xxx_code: Contains the specific error code for Cloudflare-generated errors. This field will only work for Cloudflare-generated errors such as 52X and 1XXX.
Custom JSON response for all 5XX errors
This example configures a custom JSON error response for all 5XX errors (500-599) in a zone. The HTTP status code of the custom error response will be set to 530.
Custom error rule configuration:
-
Name:
Custom JSON response for all 5XX errors -
If incoming requests match > Custom filter expression:
Field Operator Value Logic Response Status Code greater than or equal to 500And Response Status Code less than or equal to 599If using the Expression Editor:
(http.response.code ge 500 and http.response.code le 599) -
Response type: JSON response
-
Response code:
530 -
JSON response:
{"message": "A server error occurred."}
<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "json_response_for_5xx_errors", action: "serve_error", action_parameters: { content: '{"message": "A server error occurred."}', content_type: "application/json", status_code: 530, }, expression: "http.response.code ge 500 and http.response.code lt 600", enabled: true, }, ], }} />
This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.
Custom HTML response with updated status code
This example configures a custom HTML error response for responses with a 500 HTTP status code, and redefines the response status code to 503.
Custom error rule configuration:
-
Name:
Custom HTML response for 500 errors -
If incoming requests match > Custom filter expression:
Field Operator Value Response Status Code equal to 500If using the Expression Editor:
(http.response.code eq 500) -
Response type: HTML response
-
Response code:
503 -
HTML response:
<!DOCTYPE html><html><head><meta charset="utf-8"><title>Application unavailable</title></head><body><h1>Application temporarily unavailable</h1><p>Please try again later.</p></body></html>
<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "html_response_500_to_503", action: "serve_error", action_parameters: { content: '
Application temporarily unavailable
Please try again later.
', content_type: "text/html", status_code: 503, }, expression: "http.response.code eq 500", enabled: true, }, ], }} />This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.
Custom HTML response for Cloudflare 1020 errors
This example configures a custom HTML error response for Cloudflare error 1020 (Access Denied).
Custom error rule configuration:
-
Name:
Custom HTML response for 1020 errors -
If incoming requests match > Custom filter expression
Use the Expression Editor:
(cf.response.1xxx_code eq 1020) -
Response type: HTML response
-
HTML response:
<!DOCTYPE html><html><head><meta charset="utf-8"><title>Access denied</title></head><body><h1>You do not have access to this page</h1><p>Contact us if you think this is an error.</p></body></html>
<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "html_response_cf_1020", action: "serve_error", action_parameters: { content: '
You do not have access to this page
Contact us if you think this is an error.
', content_type: "text/html", }, expression: "cf.response.1xxx_code eq 1020", enabled: true, }, ], }} />This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.
Custom error asset created from a URL
This example configures a custom error rule returning a previously created custom error asset named 500_error_template for responses with a 500 HTTP status code.
Custom error rule configuration:
-
Name:
Serve asset for HTTP 500 errors -
If incoming requests match > Custom filter expression:
Field Operator Value Response Status Code equal to 500If using the Expression Editor:
(http.response.code eq 500) -
Response type: Custom error asset
-
Asset:
500_error_template
<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "serve_error_500_asset", action: "serve_error", action_parameters: { asset_name: "500_error_template", content_type: "text/html", }, expression: "http.response.code eq 500", enabled: true, }, ], }} />
This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.
Custom Errors
import { Render, Steps } from "~/components";
Use Custom Errors to replace default Cloudflare error pages with your own custom content. Custom error content is shown to visitors when an HTTP error occurs, whether the error comes from your origin server, a Cloudflare product (including Cloudflare Workers), or a security challenge.
You can configure custom error content using the following methods:
- Error Page: An HTML page shown to website visitors when a specific error occurs (refer to the different error page types) or when showing a security challenge. Error Pages can be defined at the zone level and at the account level on paid plans, with zone-level configurations taking precedence.
- Custom Error Rule: Defines the conditions under which Cloudflare will serve a custom error response to visitors in case of HTTP errors (status codes
400and above), and the exact content that will be served. A matching custom error rule has priority over an Error Page configured at the account or at the zone level that would apply to the same error.
Custom Errors require that you proxy the DNS records of your domain (or subdomain) through Cloudflare.
How it works
Cloudflare has a set of default pages for presenting errors and challenges to your website visitors. You can customize those pages using Error Pages and Custom Error Rules.
When an error of a specific type occurs, Cloudflare does the following:
- Search for a configured Error Page at the account level for the specific error.
- Search for a configured Error Page at the zone level for the specific error (it will have priority over the account-level Error Page, if any).
- Search for a matching custom error rule at the account level. The rule will have priority over 500 class and 1000 class Error Pages at the account or zone level.
- Search for a matching custom error rule at the zone level. The rule will have priority over 500 class and 1000 class Error Pages at the account or zone level and over custom error rules at the account level.
- If a security rule like a WAF custom rule or a rate limiting rule triggers a custom block response instead of a default Cloudflare WAF block page, the rule-specific block response will have priority over Error Pages or a matching custom error rule.
- If any of the previous configurations apply, serve the custom error content to the visitor. If not, serve the default error page for the specific error type in the format the client requested (JSON, Markdown, or HTML). For more details on structured error responses (JSON or Markdown), refer to Error responses.
:::note To customize a challenge page or the default Cloudflare WAF block page, use an Error Page. Custom Error Rules do not apply to security actions originating from Cloudflare products (such as the default WAF block page) — they only override error responses from your origin server or custom WAF responses. A custom WAF response configured directly in a WAF rule action takes precedence over both an Error Page and a custom error rule. :::
Availability
Custom Errors are available to all paid plans. The exact features depend on your Cloudflare plan.
| Free | Pro | Business | Enterprise | |
|---|---|---|---|---|
| Availability | No | Yes | Yes | Yes |
| Number of rules | 0 | 25 | 50 | 300 |
| Number of assets | 0 | 25 | 50 | 300 |
| Error Pages | No | Yes | Yes | Yes |
| Origin Error Pages | No | No | No | Yes |
Error Pages
Cloudflare uses a wide range of error codes to identify issues in handling request traffic. By default, these error pages mention Cloudflare; however, you can create custom error pages to provide a consistent brand experience for your users.
Error Pages do not apply to responses with an HTTP status code of 500, 501, 503, or 505. These exceptions help avoid issues with specific API endpoints and other web applications. You can still customize responses for these status codes using Custom Error Rules.
If you are on a Cloudflare paid plan, you can create custom error pages at the zone level or for your entire account. Zone-level error pages have priority over account-level error pages.
Additionally, Enterprise customers can customize 5XX error pages (except errors 520-527) at their origin by turning on Origin Error Pages in Error Pages in the dashboard.
You can design custom error pages to appear during a security challenge or when an error occurs. For more information on the different error page types, refer to Error page types.
:::note
Cloudflare will return the default Cloudflare error page instead of your custom Error Pages if the incoming request does not contain an accept-encoding header. This does not apply to responses originating from Custom Error Rules.
:::
Custom Error Rules
A custom error rule defines the conditions under which Cloudflare will serve custom error content to visitors in case of HTTP errors (status codes 400 and above), and the exact content that will be served to visitors.
When defining the content to serve, you provide either an inline response or the URL of an existing webpage. The URL can point to a webpage or to a different resource such as JSON content.
When you provide a URL, Cloudflare will gather any required images, CSS, and JavaScript code and save a minified version of the full page in the Cloudflare global network. This resource is called a custom error asset, which you can use in one or more custom error rules in the same scope of the asset (zone or account).
When a custom error rule is triggered, Cloudflare will replace the body with the response you previously defined and (optionally) the response HTTP status code sent to the visitor. Cloudflare will keep any existing HTTP response headers except for Content-Type and Content-Length.
Additionally, you can configure Response Header Transform Rules for error responses to add, change, or remove HTTP headers from the response.
Custom error rules have priority over Error Pages.
Custom Error Assets
A custom error asset corresponds to a web resource such as an HTML web page (including any referenced images, CSS, and JavaScript code) that Cloudflare fetches and saves based on a URL you provide, to be served to visitors as an error page.
Once the custom error asset is stored in Cloudflare's global network, the URL you initially provided no longer needs to be available. You can update an existing custom error asset by fetching it again. The metadata associated with each custom error asset includes the timestamp when the last fetch occurred, and this information is displayed in the dashboard.
You can use a custom error asset in one or more custom error rules in the same scope where you defined the asset (zone or account).
Size limits
When you provide a URL for a custom error asset, Cloudflare fetches the page and inlines all referenced resources into the HTML. Images and other binary resources (including those referenced from CSS via url(...)) are inlined as base64-encoded data URLs. CSS and JavaScript files are inlined as plain text inside <style> and <script> tags. The processed page must not exceed approximately 1.5 MB.
If your custom error asset exceeds this size, reduce the number or size of referenced resources. You can also host large resources externally, as long as they remain accessible from Cloudflare's network when the asset is fetched.
:::caution[Large assets increase bandwidth]
Because a custom error asset is served to every visitor that triggers the associated rule, a large asset can generate significant egress traffic. To reduce bandwidth and improve load times, keep the asset small by reducing the size or number of referenced images, fonts, and other binary resources. Cloudflare inlines referenced resources when fetching the asset, so external URLs are fetched and inlined as well.
:::
Troubleshoot Error Pages issues
If Cloudflare cannot load your site or you have blocked the United States (US) via IP Access rules or WAF custom rules, publishing and previewing a custom error page might not work.
A common error might look like the following: Error fetching page: Fetch failed, https://example.com/ipcountryblock.html returned 403 (Code: 1202).
Make sure that no WAF rule is blocking or challenging Custom Errors product when it is fetching the content of your custom error page.
Error pages for blocked requests
If you block countries or IP addresses with an IP Access rule, affected visitors will get a 1005 error and your IP/Country Block custom page.
If you block countries or IP addresses with a WAF custom rule and you do not configure a custom error rule or a WAF custom response for blocked requests, affected visitors will get your WAF Block page.
If you block requests due to a rate limiting rule and you do not configure a custom error rule or a WAF custom response for blocked requests, affected visitors will get your 429 Errors page displaying a Cloudflare 1015 error.
If you block countries or IP addresses with a firewall rule (now deprecated), affected visitors will get your 1000 Class Errors page.
1XXX errors
You cannot customize the following 1XXX errors via Error Pages:
1001- Unable to resolve1003- Bad Host header1018- Unable to resolve because of ownership lookup failure1023- Unable to resolve because of feature lookup failure
Custom error page size
Your custom error page cannot be blank and the combined size of all page assets cannot exceed 1.5 MB (1,500,000 characters). To avoid exceeding the custom error page limit, preview your page to check its size before publishing.
General troubleshooting advice
If you encounter errors while attempting to preview or publish your custom error page, use an HTML validator to ensure that your code resolves properly.
More resources
Error page types
| Page type | Description | API identifier |
|---|---|---|
| WAF block | The page displayed when visitors are blocked by a Web Application Firewall rule. This page returns a 403 status code. |
waf_block |
| IP/Country block | The page displayed when a request originates from a blocked IP address or country. This page returns a 403 status code. |
ip_block |
| IP/Country challenge | Presents a challenge to visitors from specified IP addresses or countries. This page returns a 403 status code. For more information, refer to IP Access rules. |
country_challenge |
| 500 class errors | 500 class error pages are displayed when a web server is unable to process a request. For more information, refer to Cloudflare 5xx errors. | 500_errors |
| 1000 class errors | 1000 class error pages are displayed when a domain’s configuration, security settings, or origin setup prevents Cloudflare from completing a request. For more information, refer to Cloudflare 1xxx errors. | 1000_errors |
| Managed challenge / I'm Under Attack Mode | Presents different types of challenges to a visitor depending on the nature of their request and your security settings. This page returns a 403 status code. For more information, refer to Under Attack mode. |
managed_challenge |
| Rate limiting block | Displayed to visitors when they have been blocked by a rate limiting rule. This page returns a 429 status code. |
ratelimit_block |
Error tokens
Each custom error token provides diagnostic information or specific functionality that appears on the error page. Certain error pages require a page-specific custom error token.
To display a custom page for each error, create a separate page per error. For example, to create an error page for both IP/Country Block and Interactive Challenge, you must design and publish two separate pages.
The following custom error tokens are required by their respective error pages:
| Token | Required for |
|---|---|
::CAPTCHA_BOX:: |
Interactive Challenge Country Challenge (Managed Challenge) Managed Challenge / I'm Under Attack Mode (Interstitial Page) |
::IM_UNDER_ATTACK_BOX:: |
Non-Interactive Challenge |
::CLOUDFLARE_ERROR_500S_BOX:: |
5XX Errors |
::CLOUDFLARE_ERROR_1000S_BOX:: |
1XXX Errors |
Each custom error token has a default look and feel. However, you can use CSS to stylize each custom error tag using each tag's class ID. All the external resources like images, CSS, and scripts will be inlined during the process. As such, all external resources need to be available (that is, they must return 200 OK) otherwise an error will be thrown.
For Custom Error Assets, inline responses, and Error Pages
A custom error asset, inline response, or error page may also include the following error tokens, which will be replaced with their real values before sending the response to the visitor:
| Token | Description |
|---|---|
::CLIENT_IP:: |
The visitor's IP address. |
::RAY_ID:: |
A unique identifier given to every request that goes through Cloudflare. |
::GEO:: |
The country or region associated with the visitor's IP address. |
Reference
import { DirectoryListing } from "~/components";
This section contains reference information for Custom Errors.
Custom Errors parameters
import { Type, MetaInfo } from "~/components";
Custom error rules
Custom error rules define when a custom error gets triggered and the content that is served to visitors. Rule parameters are the following:
Response type
API name: N/A (handled via asset_name and content_type parameters)
The content type of the inline response to send to the website visitor (JSON, HTML, Text, or XML), or Custom error asset if sending the content of a custom error asset.
When using the API you must either set the asset_name or set both the content_type and content parameters. Refer to JSON response / HTML response / Text response / XML response.
Response code
API name: status_code
The HTTP status code of the response. If provided, this value will override the current response status code.
The status code must be between 400 and 999.
Asset
API name: asset_name
The name of the custom error asset you previously uploaded (in the dashboard, you can create an asset when creating the rule). The asset may include error tokens that will be replaced with real values before sending the error response to the visitor.
A custom error rule can only reference an asset defined in the same scope as the rule (that is, in the same zone or account).
In the dashboard, this parameter is only available when you select Custom error asset in Response type.
When using the API, you must provide either the asset_name or the content parameter.
JSON response / HTML response / Text response / XML response {/* response */}
API names: content and content_type
The response body to return. It can include error tokens that will be replaced with real values before sending the error response to the visitor.
You must provide either the asset_name or the content parameter.
The maximum content size is 10 KB.
When using the API you must also set the content_type parameter, which defines the content type of the returned response. The value must be one of the following:
text/htmltext/plainapplication/jsontext/xml
:::caution
If you create an HTML error response, make sure the referrer meta tag is not present in the HTML code since it will disrupt Cloudflare challenges:
<meta name="referrer" (...) />
:::
[...]
